       subroutine ferseldh(iev,energy,trace,hdep,elgmu)
c     input file: energysum.dep  contains Es, Mo, focal mechanisms, depths and
c       magnitudes for teleseismic earthquakes from 1987 to 2013.       

c       global search can be obtained with a c/r or 01040914)
c       option 00, for a rectangle 
       integer lc(24),feno,nsta,ndc(3)
       real lat,lon,mb,ms,strike(3,2),dip(3,2),slip(3,2),hdep(10000)
       real energy(10000),trace(10000),elgmu(10000),dep(3)
       character*1 ans,soutypf,soutypb,soutypc, ansoc
       character*2 iopt(24),echr(24),fmtyp,dchr,fmchr,regchr,qchr,geochr
    	 character*3 dchr3
       character*4 name(5)
       character*32 title2,msg(4)
       character*32 filenm4, filenm,filenm2, filenm3
       logical yorn, ex
c      24 options used; to increase options change array
c      sizes of lc,iopt, and echr; data statement of echr; 
c      do loop ranges at statements 55,1,33,39 automatically
c	changed with variable nopt, so change value of nopt.
c      Also, need format changes at 12, and 103 (both the read and format)
c	and the write(6,*) statement after the do loop with statement 1.
       data iopt/'ad','sh','dp','af','th',
     2           'nr','ss','ma','at','os',
     3           'cs','rf','ic','aq','gd',
     4           'fr','nd','fe','tr', 'tt',
     5           'ba','cr','io','om'/
       data echr/24*'  '/
       data name/'.bm1','.cm1','.mb1','.ms1','.mmt'/
       data msg/'USGS Moment','Centroid Moment','mb','MS'/
c       this subroutine is intended as a convenient place
c       to choose subsets of data from energysum.lis or energysum.dep
c       for use with lognrg and semilog programs.
c
c       iev is number of data points in selected subset (determined here)
c       energy is energy array of the subset
c       trace
c       types of subduction zone: oceanic trench, os
c              continental collision, cs (e.g., Himalayas)
c              trench-trench junction, tt; 
c	       intraplate cont., ic; intraplate oceanic, io;
c              oceanic ridge (rf) including transforms in mid-ocean;
c              and continental rift (cr);
c              continental transforms (tr)
c              ba, back arc (mostly needed for strike-slip)
c              triple junction (tt) including near indentors and
c              intersections of plates (only oceanic, so these
c              would include most ocean-side intraplate events)
c              
c              ityp indicates what type of data (e.g., cmt/bmt) was used.
       yorn=.false.
       kl=0
       filenm2=' '
      inferno=0
	nopt = 24
       dep1 = 0.
       dep2 = 900.
	twothrds = 2./3.
550	write(6,*) ' Enter Me threshold with decimal (c/r to skip)'
	read(5,261) nq, emagmin
261	format(q, f)
	if(nq.eq.0) emagmin = 0.0
	if(emagmin.eq.0.0) go to 551
	if( emagmin.lt.0.1) go to 550
551	write(6,*) ' Me threshold ', emagmin
553	write(6,*) ' Enter Mw threshold with decimal (c/r to skip)'
	read(5,261) nq, wmagmin
	if(nq.eq.0) wmagmin = 0.0
	if(wmagmin.eq.0.0) go to 552
	if(wmagmin.lt.0.1) go to 553
	idiffmag=1
552	write(6,*) ' Mw threshold ', wmagmin
	write(6,*) ' Enter diffmag (Me-Mw) threshold w/decimal (c/r to skip)'
	read(5,261) nq, diffmag
	if(nq.eq.0) idiffmag=0
	if(idiffmag.eq.1) then
	write(6,*) ' Events with Me-Mw >' ,diffmag, ' will be skipped'
	else
	write(6,*) ' No filtering for diffmag will be done'
      endif
c554	continue
c	for non-standard file by itself, e.g., special data set and
c	no search of the entire database, enter the specific file
c	name here (e.g., shthchile.cm1)
260    continue
      write(6,109)
109    format(' Default data file name energysum.dep')
99     format(q,a)
       write(6,*) 'Looking for energysum.dep'
       filenm4 = 'energysum.dep'
       inquire(file = filenm4, exist = ex)
       if(ex) go to 259
       if(.not.ex) write (6,*) 'Did not find data file: ',filenm4
       if(.not.ex) write (16,*) 'Did not find data file: ',filenm4
      pause
      call exit
259    write(6,*)' Display menu y(es default) or n(o):'
       read(5,11) nchr, ans
11       format(q,a1)
	if(nchr.eq.0) ans = 'Y'
       if(ans.eq.'y'.or.ans.eq.'Y')       write(6,10)
10      format('  c/r or 010409 for ALL earthquakes,  '/
     1  '     00 = rectangular boundaries'/
     1  '     Must specify depth, mech, and tectonic attribute'/
     1  '     01 = ALL depths'/
     2  '        02 = shallow earthquakes (<70 km)'/
c       the shallow (sh) designation is defined as 70 km in legacy literature
     3  '        03 = choose depth range'/
     3  '     04 = ALL mechanisms'/
     5  '        05 = thrust mechanisms'/
     4  '        06 = normal mechanisms'/
     7  '        07 = strike-slip mechanisms'/
     6  '        08 = marginal mechanisms'/
     9  '     09 = ALL tectonic environments'/
     7  '       10 = oceanic subduction events'/
     1  '       11 = continental collision events'/
     7  '       13 = cont intraplate'/
     2  '       19 = cont transforms'/
     7  '       22 = continental ridge-rift'/
     2  '       12 = oceanic ridge-rift events'/
     7  '       20 = oceanic triple-junctions or indentors'/
     7  '       21 = oceanic back-arc'/
     7  '       23 = oceanic intraplate'/
     7  '       24 = oceanic microplate'/
     7  '    18 = for Flinn-Engdahl seismic region')
44     write(6,*)' Enter DESIRED attributes in sequence, I2 format:'
       geochr = '  '
       do 55 i=1, nopt
       echr(i)='  '
55       lc(i)=0
       read(5,103) nchr, (lc(i),i=1,nopt)
103       format(q,24i2)
       if(nchr.eq.0) then
       lc(1) = 3
       lc(2) = 4
       lc(3) = 9
       lc(4) = 14
       nchr = 8
       endif
       if(lc(2).eq.0) then
       lc(2) = 4
       nchr = nchr + 2
       endif       
       if(lc(3).eq.0) then
       lc(3) = 9
       nchr = nchr + 2
       endif       
       if(lc(4).eq.0) then
       lc(4) = 14
       nchr = nchr + 2
       endif       
       lnum=(nchr+1)/2
       write(6,*) ' no. pairs', lnum
       do 57 i = 1,lnum
       if(lc(i).eq.14) go to 58
       if(lc(i).eq.15) go to 58
       if(lc(i).eq.16) go to 58
57       continue       
       lnum = lnum + 1
       lc(lnum) = 14
58     continue
c      lc coefficients must be ordered; if out of order, the search
c      algorithm may find zero events.
       do 56 ii = 2, lnum
       do 56 i = 2, lnum
       idum = lc(i)
       if(lc(i).lt.lc(i-1)) then              
       lc(i) = lc(i-1)
       lc(i-1) = idum
       endif       
56        continue
       write(6,12)(lc(i),i=1,lnum)
12       format(' Options chosen:',24(1x,i2))
       write(6,*)' Continue (C/R) or redo (y):'
       read(5,13) nchr, ans
13       format(q,a1)
       if(ans.eq.'y'.or.ans.eq.'Y')go to 44
        j=1
        if(lc(1).ne.0) go to 15
       geochr='al'
       j=2
15     continue
       do 1 i=1, nopt
       if(i.ne.lc(j))go to 1
       echr(i)=iopt(i)
       j=j+1
1      continue
c     option for specifying lat-lon rectangle is when lc(1)=0; 
       if(geochr.eq.'al') write(6,*) 'rectangle search ', geochr
       write(6,*) (i, echr(i), i = 1, nopt)
        if(geochr.eq.'al') then
        write(6,*) ' Enter 2 latitude corners'
        read(5,*) elat1, elat2
        if(elat1.lt.elat2) then
        eminlat = elat1
        emaxlat = elat2
        else
        eminlat = elat2
        emaxlat = elat1
        endif
        write(6,*) ' Enter 2 longitude corners'
        read(5,*) elon1, elon2
        write(6,*) ' Two latitudes are: ', eminlat, emaxlat
        write(6,*) ' Two longitudes are: ', elon1, elon2  
c       have to figure out how to handle all lat/lon contingencies
c       negative/negative and positive/positive require no change.
c       neg/pos about 0 degrees requires no change
        addlon = 0.
        if(elon1.ge.0..and.elon2.ge.0.) go to 6444
        if(elon1.le.0..and.elon2.le.0.) go to 6444
        if(abs(elon1).le.90..and.abs(elon2).le.90.) go to 6444
c       only neg/pos about 180 degree requires change 
        addlon = 360.
        if(elon1.lt.0.) elon1 = elon1 + addlon
        if(elon2.lt.0.) elon2 = elon2 + addlon
        write(6,*) ' Adjusted longitudes are: ', elon1, elon2
        endif
6444    continue
c       determine min and max value.
        if(elon1.lt.elon2) then
        eminlon = elon1
        emaxlon = elon2
        else
        eminlon = elon2
        emaxlon = elon1
        endif
c	
c	depths of all events with unequivocal continental or oceanic locations use
c     continental/oceanic crustal model, respectively.  However, for events near
c     subduction zones, the neic practice of using a radially homogeneous earth
c     model (JB and later iasp91) is used. For apparent stress, mu is computed 
c     using the velocity at the depth of the earthquake.
c    
c	jun 2006:  I straightened out crustal model usage for strike slip
c     events up to 2004 for the following categories:
c	"os" is for continental crust strike-slip events near subduction zone.
c	"tt" is for oceanic crust strike-slip near and landward of subduction.
c	thus, for "os" and "ss" use continental mu.  No change in program
c	needed.  

       if(echr(16).eq.iopt(16)) echr(15) = iopt(15)
       if(echr(3).eq.iopt(3)) then
       write(6,41)
41       format(1x, 'Choose depth range for deep earthquakes:'
     1  /' (1) for  70-150 km'
     2  /' (2) for 150-300 km'
     3  /' (3) for 300-420 km'
     4  /' (4) for greater than 420 km'
     5  /' (5) for  70-800 km'
     6  /' (6) enter other range' )
       read(5,*) jtyp
       if( jtyp .eq. 1) dep1 = 70.
       if( jtyp .eq. 1) dep2 = 150.
       if( jtyp .eq. 2) dep1 = 150.
       if( jtyp .eq. 2) dep2 = 300.
       if( jtyp .eq. 3) dep1 = 300.
       if( jtyp .eq. 3) dep2 = 420.
       if( jtyp .eq. 4) dep1 = 420.
       if( jtyp .eq. 4) dep2 = 800.
       if( jtyp .eq. 5) dep1 = 70.
       if( jtyp .eq. 5) dep2 = 800.
       if( jtyp .eq. 6) then 
       write(6,*) ' Enter smaller depth:'
       read(5,*) dep1       
       if(dep1.eq.0.) dep1 = 0.1
       write(6,*) ' Enter larger depth:'
       read(5,*) dep2
       endif
       write(6,*) ' Greater than or equal to ',dep1,
     2 ' less than or equal to',dep2
       endif
       write(6,40)
40       format(1x,' Choose variable to plot with Energy:'
     1  /'     1  bmt'
     2  /'     2  cmt (default c/r)'
     3  /'     3  mb'
     4  /'     4  Ms'
     5  /'     5 cmt/bmt')
       read(5,'(q,i)') nq, ityp
       if(nq.eq.0) ityp=2
c       write(6,*) 'ityp ', ityp
       kl=0
       ncut=100
       mdtyp=mod(ityp,4)
1001       if(echr(18).ne.iopt(18))go to 1002
      write(6,*) ' Enter No. for FE Seismic Region'
	write(6,*) ' Note: only does one FE number at a time'
	write(6,*) ' Output name as FE number in prefix'
	write(6,*) ' Depth, FM and Tectonic attributes must ',
     2 'have been specified above'
       read(5,*) inferno
       write(6,*) ' FENO: ', inferno
       lnum=lnum+1
       if(inferno.le.99)write(dchr,105)inferno
105       format(i2.2)
	if(inferno.ge.100) write(dchr3,108) inferno
108	format(i3.3)
1002       j=0
       filenm=' '
       if(geochr.eq.'al') then
       j=1
       filenm(2*j-1:2*j)=geochr
       write(6,*) filenm
       endif
       do 33 i=1, nopt
       if(i.eq.9.or.i.eq.14) then
       lnum = lnum -1 
       go to 33
       endif
       if(echr(i).ne.'  ') then
              j=j+1
              filenm(2*j-1:2*j)=echr(i)
       endif
33       continue
       if(inferno.ne.0) then 
              j=j+1
		if(inferno.le.99) then		
              filenm(2*j-1:2*j)=dchr
		endif
		if(inferno.ge.100) then
              filenm(2*j-2:2*j)=dchr3
		endif		
       endif
       filenm3 = filenm
       filenm2 = filenm
       filenm(j*2+1:j*2+4)=name(ityp)
       filenm3(j*2+1:j*2+4) = '.anm'
       filenm2(j*2+1:j*2+4) = '.ext'
       write(6,101) filenm4, filenm, filenm3, filenm2
101     format(1x,'Input: ', 12x, a,2x,/' Short output file: ',a,
     2  /,5x,'Anomalous tau: ', a,2x,/'Extended output file: ', a)
      nchr=0
31       format(q,a32)
       open(15,file=filenm4,status='old',form='formatted')
       open(16,file=filenm,status='unknown',form='formatted',
     2  carriagecontrol='list')
       open(66,file=filenm3,status='unknown',form='formatted',
     2  carriagecontrol='list')
       open(86,file=filenm2,status='unknown',form='formatted',
     2  carriagecontrol='list')
       tsum = 0.
       esum = 0.
       isum = 0.
c	for strike-slip eqs, try anomtau = 50
c	for thrust and normal eqs, try anomtau = 20
       anomtau = 20.
       write(6,*) ' Identify high apparent stress events (>20 bars)'
       write(6,*) ' Change tau value? y(es) or n(o default 20 bars)'
       read(5,11) nchr, ans
       if(nchr.eq.0.or.ans.eq.' ') go to 27
       if(ans.eq.'n'.or.ans.eq.'N') go to 27
       write(6,*) ' Enter new anomalous tau threshold:'
       read(5,*) anomtau
27       continue
       write(6,*) ' Anomalous tau set at:',anomtau, ' bars'
       write(16, 119) filenm(1:lnum*2+6)
       write(66, 118) filenm3(1:lnum*2+6),anomtau
118   format(1x,a,3x,'taua level > ',f7.1,' bars')       
       do 2 i=1, 10000
	yorn =.false.
c     to handle end of file, use end=	
       read(15,20,err=250,end=250)inum,nyr,nmo,nda,time,lat,lon,
     2 feno,title2
20       format(i4,1x,i4,i2,i2,1x,f9.2,1x,f7.3,1x,f8.3,1x,i3,1x,a32)
       read(15,59)mb,ms,fmtyp,dchr,fmchr,regchr
59       format(3x,2(1x,f3.1),1x,a1,3(1x,a2))
       read(15,69)soutypf,(strike(1,k),dip(1,k),slip(1,k),k=1,2),
     2  dep(1),engy
69       format(4x,a1,6(1x,f5.0),1x,f5.1,1x,e10.2)
       read(15,79)soutypb,(strike(2,k),dip(2,k),slip(2,k),k=1,2),
     2  dep(2),bmt
79       format(4x,a1,6(1x,f5.0),1x,f5.1,1x,e10.2)
       read(15,79)soutypc,(strike(3,k),dip(3,k),slip(3,k),k=1,2),
     2  dep(3),cmt
     
c     Retroactive depths (i.e., not computed in time for Monthly
c     PDE) and held depths are indicated by negative depth.  Negative sign
c     is not printed in output.  
c	Some important earthquakes like Landers were held at h=10 km 
3002	continue
	if(echr(1).eq.'al'.and.dep(1).eq.0.0) dep(1) = 1.0
	if(dep(1).eq.0.0)  go to 2
       if(dep(1).lt.0.) dep(1) = -dep(1)
c     Note:  apparent stress depends on mu which is depth dependent. 
28       continue
c       do rectangular boundaries here.
        if(geochr.ne.'al') go to 6555
        if(lat.le.emaxlat.and.lat.ge.eminlat) then
        londum = lon + addlon
        else
        go to 2
        endif
        if(londum.le.emaxlon.and.londum.ge.eminlon) go to 6555
        go to  2
6555    continue
c       if(echr(1).eq.'al')go to 23
c       test for depth range
       if(echr(1).eq.iopt(1))go to 5
c       originally, no test for depth if dchr=shallow
c       if jtyp = 6, we want to search for a given depth range,
c       regardless of whether dchr = sh/dp
       if(dchr.eq.echr(2)) then
       dep1 = 0.1
       dep2 = 70.
       go to 5
       endif
       if( echr(3).eq.dchr.or.jtyp.eq.6) then
       if(dep(1) .ge. dep1 .and. dep(1) .le. dep2) go to 5
       endif
       go to 2
5       continue
       if(echr(4).eq.iopt(4)) go to 7
       do 6 j=5,8
       if(fmchr.eq.echr(j)) go to 7
6       continue
       go to 2
c       test for tectonic environment
7       continue
       if(echr(9).eq.iopt(9)) go to 8
       do 9 j=10,13
       if(regchr.eq.echr(j)) go to 8
9       continue
       do 39 j=19, nopt
       if(regchr.eq.echr(j)) go to 8
39       continue
       go to 2
8       continue
       if(echr(14).eq.iopt(14)) go to 22
       do 21 j=15,16
       if(qchr.eq.echr(j))go to 22
21       continue
       go to 2
22       continue
       if(echr(17).ne.iopt(17))go to 23
       if(mdtyp.eq.1) then
              if(ndc(2).lt.ncut) go to 23
              go to 2
       else if (ityp.eq.2) then
              if(ndc(3).lt.ncut) go to 23
              go to 2
       endif
23       continue
       if(echr(18).ne.iopt(18)) go to 24
       if(feno.eq.0) write(6,*)'feno zero at',inum
c	Hint:  easy way to find flinn-engdahl number is too look in
c     data file energysum.dep for a region name.  The data line
c     contains the flinn-engdahl number.
	if(feno.eq.inferno) then
	yorn =.true.
	endif
       if(.not.yorn) go to 2
24       continue
c	put in an Me/Mw threshold here.  
c	a high tau alone is not enough to distinguish a dangerous shaking
c	earthquake.  Maybe there is a minimum Es or minimum area affected
c	(Mo) that is required before a felt report can be generated.
	emag2 = 0.
	if(engy.ne.0) then
c     for consistency with Bormann NMSOP, use new constant to avoid
c     roundoff errors.	
        emag2 = twothrds*(alog10(engy)) - 2.933
	endif
c       to omit energies if either moment was not computed.
c       if(bmt.eq.0..or.cmt.eq.0.)go to 2
c	if the desired moment is non-zero, don't skip.  The current statement
c	causes skip, e.g., if bmt =0 while cmt.ne.0 even if we want cmt.
	if(bmt.eq.0.and.ityp.eq.1) go to 2
	if(cmt.eq.0.and.ityp.eq.2) go to 2
       kl=kl+1
       energy(kl)=engy
       if(ityp.eq.5) energy(kl)=cmt
       if(mdtyp.eq.1)trace(kl)=bmt
       if(ityp.eq.2)trace(kl)=cmt
       if(ityp.eq.3)trace(kl)=mb
       if(ityp.eq.4)trace(kl)=ms
	if(mdtyp.eq.1.or.ityp.eq.5.or.ityp.eq.2) then
		if(trace(kl).ne.0.) then
c     Use constant 6.066 instead of 6.0 to eliminate roundoff discrepancy
c     between Hanks & Kanamori formula vs modern formula
		wmag2 = twothrds*alog10(trace(kl)) - 6.066
		if(emag2.lt.emagmin.or.wmag2.lt.wmagmin) go to 2
		if(idiffmag.eq.1.and.(emag2 - wmag2) .gt. diffmag) go to 2
		endif
	endif
	xdep = dep(1)
	rad = 6371. - xdep
       call gcvel(rad,vp,vs,rho,avvp)
c       density gm/cm**3; vs km/sec; mu 10**10 gm/cm-sec2 = 10**4 bars
c       elgmu to keep precision.
c       do not include events on or before 1986, in summary as energy
c       was not computed routinely before 1986
       if(nyr.le.1986) go to 121
       tsum = tsum + trace(kl)
       esum = esum + energy(kl)
c       isum = no. events in summation
       isum = isum + 1
c       for the last event, the fraction of the last year is from 
c       January to the last month
c       e.g., march 1996 has (1995*12 + 3) months.  Note that we start
c       with the previous year which had the complete 12 months.
       nmon2 =(nyr-1)*12 + nmo 
c       similarly, for the first event, we subtract from nmon1 the fraction 
c        of the        year that has elapsed up to that time
c       e.g., march 1990 has (1989*12 + 3 ) months.
c       Note that we start the previous year, 1989, because 1990 was not
c       finished.  The (-1) is for bookkeeping.
       if(isum.eq.1) nmon1 = (nyr-1)*12 + nmo -1
c       write(6,*) nmon1, nyr, nmo
121       continue
       if(ityp.ne.5) then
       hdep(kl) = dep(1)
       elgmu(kl) = alog10(rho*vs*vs) + 4.
       xmu = 10**elgmu(kl)
       tau = 0.
       if(ityp.ge.3) go to 301
       if(trace(kl).ne.0.) then
	tau = xmu*energy(kl)/trace(kl)       
      if(tau.ge.anomtau) write(66,100)inum,energy(kl),trace(kl),
     2  nyr,nmo,nda, lat,lon, hdep(kl), tau, title2
       endif
301       continue
	endif
       write(16,100)inum,energy(kl),trace(kl),nyr,nmo,nda,
     2  lat,lon, hdep(kl), tau, title2
100       format(i4, 2(e9.2), 1x, i4, i2, i2, 1x, f5.1, 1x,f6.1, 
     2  1x, f4.0,1x,f5.1,1x, a27)
c     for complete output     
	if(fmtyp.eq.soutypf) ii = 1
	if(fmtyp.eq.soutypb) ii = 2
	if(fmtyp.eq.soutypc) ii = 3
c     only one fault plane is written out	
      write(86,200)inum,energy(kl),trace(kl),nyr,nmo,nda,
     2  lat,lon, hdep(kl), tau, title2, strike(ii,1),dip(ii,1),
     3  slip(ii,1),mb,ms,emag2,wmag2
200       format(i4, 2(e9.2), 1x, i4, i2, i2, 1x, f5.1, 1x,f6.1, 
     2  1x, f4.0,1x,f5.1,1x, a27, 3(1x,f5.0), 4(1x,f5.2))
      
2       continue
250       continue
	write(6,*) ' ended at inum', inum
253	continue
      iev=kl
       if(iev.eq.0) then
       write(6,*) filenm,' No. events is', iev
       write(16,*) filenm,' No. events is', iev
       write(16,*) 'Either there are really 0 events or you did not'
       write(16,*) 'specify depth, foc. mech and tectonic attributes'
       endif
       
       years = float(nmon2-nmon1)/12.
       if(years.eq.0.) go to 255
       tav = tsum/years
       eav = esum/years
       write(16, 119) filenm(1:lnum*2+6)
119       format(1x, a)
c     routine computation began in 1987.  Data for prior events
c     are from special papers by Choy and Boatwright or Boatwright and Choy
       write(16,120) isum
120     format(1x, 'Total no. events after 1987: ', i5)
       write(16, 107) esum, tsum
107       format(1x, 'Total Energy: ', e9.2, 5x, 'Total Moment: ',e9.2)
       if(ityp.eq.5) write(16,122) esum, tsum
122       format(1x, 'Total cmt: ', e9.2, 5x, 'Total bmt: ',e9.2)
       write(16, 110) years, eav,tav
110       format(1x, 'Average over',f5.1,' years', 2(1x,2e9.2))
255       continue
       close(15)
       close(66)
       close(16)
       close(86)
	return
351	continue
       return
256       write(6,*)' Error opening/searching for file.'
       return
       end
      subroutine gcvel(rad,vp,vs,rho,avvp)
c   model parameters for the IASPEI working model (September 1990.1).  
c   normalization: radius by radius of the earth, density by
c   the mean density of the Earth
c
      common/model/ r(14),d(13,4),p(13,4),s(13,4)
      data r/0.      ,1217.1  ,3482.0  ,3631.  ,5611.   ,5711.   ,
     1 5961.   ,6161.   ,6251.   ,6336.   ,6351.    ,6371.    ,
     2 6371.,6371./
      data d/13.01219,12.58416, 6.8143 , 6.8143 , 6.8143 ,11.11978,
     1  7.15855, 7.15855, 7.15855,  2.92  , 2.72   , 2*0.,
     2       0.     ,-1.69929,-1.66273,-1.66273,-1.66273,-7.87054,
     2 -3.85999,-3.85999,-3.85999,4*0.,
     3       -8.45292,-1.94128,-1.18531,-1.18531,-1.18531,8*0.,
     4       0.     ,-7.11215,11*0./
      data p/11.24094,10.03904,14.49470,25.1486 ,25.969838,29.38896,
     1 30.78765,25.41389, 8.785412, 6.5   , 5.8   ,2*0.,
     2       0.   , 3.75665, -1.47089,-41.1538, -16.934118,-21.40656,
     2-23.25415,-17.69722,-0.7495294, 4*0.,
     3       -4.09689,-13.67046, 0.0  ,51.9932,9*0.,
     4       0.     , 0.      , 0.     ,-26.6083,9*0./
      data s/ 3.56454, 0.      , 8.16616,12.9303 ,20.768902,17.70732,
     1 15.24213,5.750203, 6.706232, 3.75   , 3.36   ,2*0.,
     2       0.     , 0.      ,-1.58206,-21.2590,-16.531471,-13.50652,
     2-11.08553,-1.274202,-2.248585, 4*0.,
     3       -3.45241, 0.      , 0.0    ,27.8988 ,9*0.,
     4       0.     , 0.      , 0.     ,-14.1080,9*0./
      data rn,rhon/6371.,.18125793/
c       there are 13 shells for 11 layers, because you have to add 
c       in radii for center of earth, r=0, and for surface, r=6371)
c       to find average velocity above a radius, start integration
c       from surface down.  At discontinuities, choose upper velocity
       nlay = 11
       avvp = 0
       do 1 i = 1, nlay
       jtop = nlay-i+2
       jbot = nlay-i+1
       il = nlay-i+1
       if(rad.le.r(jbot)) then
       r1 = r(jbot)/rn
       r2 = r(jtop)/rn
       vpint1 = r1*(p(il,1) + r1*(p(il,2)/2. + r1*(p(il,3)/3. 
     2   + r1*p(il,4)/4.)))
       vpint2 = r2*(p(il,1) + r2*(p(il,2)/2. + r2*(p(il,3)/3. 
     2   + r2*p(il,4)/4.)))
       avvp = (vpint2-vpint1) + avvp
       if(rad.eq.r(jbot)) go to 2
       endif
       if(rad.gt.r(jbot)) go to 3
1       continue
3       r1 = rad/rn
       r2 = r(jtop)/rn
       vpint1 = r1*(p(il,1) + r1*(p(il,2)/2. + r1*(p(il,3)/3. 
     2   + r1*p(il,4)/4.)))
       vpint2 = r2*(p(il,1) + r2*(p(il,2)/2. + r2*(p(il,3)/3. 
     2   + r2*p(il,4)/4.)))
       avvp = (vpint2-vpint1) + avvp
c       write(6,*) avvp, rad, r(jtop), vpint1, vpint2
2       continue
       avvp = avvp/(1. - rad/rn)
      rho=d(il,1)+r1*(d(il,2)+r1*(d(il,3)+r1*d(il,4)))
      vp= p(il,1)+r1*(p(il,2)+r1*(p(il,3)+r1*p(il,4)))
      vs= s(il,1)+r1*(s(il,2)+r1*(s(il,3)+r1*s(il,4)))
      return
      end
       
