      program selectnrg
c     Program to extract radiated energy from data file energysum.dep
c       written by George Choy (USGS) September 2018.
c       based on a skeletonized version of logtaud3
c       Energy subsets can be based on several conditions:  depth,type
c           of mechanism, tectonic setting, seismic region (flinn-engdahl number),
c           magnitude (Me or Mw) size, differential magnitude (Me-Mw) or apparent
c           stress level.
c       Search can be global or inside a rectangular region.
c       wmag2 (Mw) and emag2 (Me) use Bormann NMSOP constants to avoid roundoff
c       discrepancies.
c       Three output files:
c           1.  file with energy and one other primary variable convenient for
c               plotting
c           2.  same file but with events have only high apparent stress (default 
c               >20 bars but can be reset)
C		calls ferseldh 
C       data
      REAL TRACE(10000)
      REAL ENERGY(10000), ELGMU(10000), HDEP(10000)
      CALL FERSELDH(IEV, ENERGY, TRACE, HDEP, ELGMU)
            IF (.NOT.(IEV.EQ.0)) GOTO 3390
              WRITE(6, *) ' No. events is', IEV
116           FORMAT(1X, 'No. events', I3)
3390        CONTINUE
c      pause
      CALL EXIT
      END
